/*main.m created by ahoesch on 25.11.2009 */

#import <Foundation/Foundation.h>
//#import <SRFoundation/SRFoundation.h>
//#import <SREnterprise/SREnterprise.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>

#define BUFLEN 512
#define NPACK 10
#define PORT 9930
//#define SRV_IP "127.0.0.1"
//#define SRV_IP "192.168.1.255"
#define GROUP_IP "224.1.2.3"

int main (int argc, const char *argv[])
  {
   NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
   
   // insert your code here
     {
      struct sockaddr_in si_other;
      int s, i, slen=sizeof(si_other);
      char buf[BUFLEN];
      if ((s = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) == -1) NSLog(@"socket could not be opened");
  
  // shouldn't be necessary
  // 2nd note: cast to (char *) isn't needed, since an implicit cast to
  // (void *) is allowed in C
//  memset((char *) &si_other, 0, sizeof(si_other));
      si_other.sin_family = AF_INET;
      si_other.sin_port = htons(PORT);
      if (inet_aton(GROUP_IP, &si_other.sin_addr)==0)
      {
         fprintf(stderr, "inet_aton() failed\n");
         exit(1);
      }
      
      // we can do a connect() here, since we'll be multicasting
      // to a single group address
      if (connect (s, (struct sockaddr *) &si_other, sizeof (si_other)) < 0)
        {
         perror ("connect()");
         exit (EXIT_FAILURE);
        }
      
      // By default, multicast packets have a ttl = 1, meaning they won't
  // leave your local broadcast segment across a router with multicast
  // routing support. If you do want to be able to route your multicast
  // packets, uncomment the following code:  
  unsigned char ttl = 255;
  if (setsockopt (s, IPPROTO_IP, IP_MULTICAST_TTL, &ttl, sizeof(ttl)) < 0)
    {
     perror ("Increasing send TTL failed");
     exit (EXIT_FAILURE);
    }
  
  for (i=0; i<NPACK; i++)
  {
         printf("Sending packet %d\n", i);
         sprintf(buf, "This is packet %d\n", i);
         if (sendto(s, buf, BUFLEN, 0, &si_other, slen) == -1)
           perror("sendto() failed");
       }   
       close(s);
     }
   
   /* *** post UDP notification *** 
     {
      SRFileHandle *fh = [[[SRFileHandle alloc] initAsClientAtAddress:@"192.168.1.255" port:PORT type:SRUDPConnection] autorelease];
      NSDictionary *userInfo = [NSDictionary dictionaryWithObject:@"Thomas" forKey:@"name"];
      NSData *data = [SRSerializer serializedObject:[NSNotification notificationWithName:SREnterpriseObjectModificationNotification object:nil userInfo:userInfo]];
      NSLog(@"Trying to send %d bates ...", [data length]);
      [fh writeData:data];
     }*/
   
   [pool release];
   exit(0);       // insure the process exit status is 0
   return 0;      // ...and make main fit the ANSI spec.
  }
